/**
 * @module mod_treasurehunt/edit
 * @package mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>,
 *            Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>*
 * @license http:// www.gnu.org/copyleft/gpl.html GNU GPL v3 or later.
 */
define(["jquery","jqueryui","mod_treasurehunt/jquery-ui-touch-punch","core/notification","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/ol3-layerswitcher","core/str","mod_treasurehunt/viewgpx"],(function(e,t,o,i,r,a,n,s,l,d){function c(t,o,s,l,c,u){var g="EPSG:3857",p=new r.proj.Projection(g),f=null,h=!0;if(void 0!==u&&null!=u){if(null!=u.custombackgroundurl){var m=function(e,t,o=!1){var i=r.proj.transformExtent(e.bbox,"EPSG:4326",t);if(1==e.preserveaspectratio){i[2],i[0];var a=i[3]-i[1],n=(i[2]+i[0])/2,s=(i[3]+i[1])/2,l=Math.round(a/e.imgheight),d=Math.round(e.imgwidth*l),c=Math.round(e.imgheight*l);o?i=[n-d/2,s-c/2,n+d/2,s+c/2]:(i=[i[0],i[1],i[0]+d,i[1]+c],console.log("Using bottom-left as reference."+i))}return i}(u,g,!1);f=new r.layer.Image({title:u.layername,type:u.layertype,source:new r.source.ImageStatic({url:u.custombackgroundurl,imageExtent:m}),opacity:1})}else if(null!=u.wmsurl){var v={source:new r.source.TileWMS({url:u.wmsurl,params:u.wmsparams}),type:u.layertype,title:u.layername};if(null!=u.bbox[0]&&null!=u.bbox[1]&&null!=u.bbox[2]&&null!=u.bbox[3]){var y=r.proj.transformExtent(u.bbox,"EPSG:4326",g);v.extent=y}f=new r.layer.Tile(v)}h=u.geographic}var b,w,F,C,I={roads:{}},P=new r.source.Vector({projection:g}),x=new r.source.Vector({projection:g}),k=!1,S=!1,E=!1,A={},z=1,T=new r.layer.Vector({source:new r.source.Vector({projection:g})});let B;function j(t,o,i,r,a,n){var s,l=e(t).get([i]),d=e(l).attr("roadid");s=Math.abs(e(l).index('li[roadid="'+d+'"]')-o),e(l).attr("stageposition",s),e(l).find(".sortable-number").text(s),e(l).hasClass("ui-selected")&&(b=s),function(e,t,o,i,r,a){var n,s=i.getFeatureById(e);s||((s=r.getFeatureById(e).clone()).setId(e),i.addFeature(s));if(s.setProperties({stageposition:t}),"empty"!==s.get("idFeaturesPolygons"))for(var l=0,d=(n=s.get("idFeaturesPolygons").split(",")).length;l<d;l++)a.getSource().getFeatureById(n[l]).setProperties({stageposition:t})}(parseInt(e(l).attr("stageid"),10),s,parseInt(e(l).attr("roadid"),10),r,a,n)}h&&(e('<div id="searchcontainer">').appendTo(e("#controlpanel")),e('<input type="search" placeholder="'+s.searchlocation+'" class="searchaddress"/>').appendTo(e("#searchcontainer")),e('<span class="ui-icon  ui-icon-search searchicon"></span>').prependTo(e("#searchcontainer")),e('<span class="ui-icon  ui-icon-closethick closeicon invisible"></span>').appendTo(e("#searchcontainer"))),e('<ul id="stagelist"/>').prependTo(e("#stagelistpanel")),e("#stagelist").sortable({handle:".handle",tolerance:"pointer",zIndex:9999,opacity:.5,forcePlaceholderSize:!0,cursorAt:{top:-7},cursor:"n-resize",axis:"y",items:"li:not(:hidden , .blocked)",helper:"clone",start:function(t,o){var i=o.item.attr("roadid"),r=o.item.index('li[roadid="'+i+'"]'),a=e(this).data("ui-sortable").scrollParent,n=a[0].scrollHeight-a[0].clientHeight-o.helper.height();o.item.data("start_pos",r),e(this).data("maxScrollTop",n)},sort:function(t,o){var i=e(this).data("ui-sortable").scrollParent,r=e(this).data("maxScrollTop");i.scrollTop()>r&&i.scrollTop(r)},update:function(t,o){var i,r=o.item.data("start_pos"),a=o.item.attr("roadid"),n=o.item.index('li[roadid="'+a+'"]'),s=e(this).children('li[roadid="'+a+'"]'),l=e(s).length;if(r!==n){if(r<n)for(i=r;i<=n;i++)j(s,l,i,P,x,I.roads[a].vector);else for(i=n;i<=r;i++)j(s,l,i,P,x,I.roads[a].vector);ee(),k=!0}}}).disableSelection(),e('<ul id="roadlist"/>').appendTo(e("#roadlistpanel")),window.app={};var G=window.app;G.generateResizableControl=function(e){var t=e||{},o=document.createElement("button"),i=document.createElement("div");o.innerHTML="<>",o.id="egrip",i.className="ol-control ol-unselectable egrip-container",i.appendChild(o),r.control.Control.call(this,{element:i,target:t.target})},r.inherits(G.generateResizableControl,r.control.Control);var _=new r.style.Style({fill:new r.style.Fill({color:"rgba(100, 100, 255, 0.2)"}),stroke:new r.style.Stroke({color:"rgba(100, 100, 255, 0.5)",width:2}),image:new r.style.Circle({radius:5,fill:new r.style.Fill({color:"#ffcc33"}),stroke:new r.style.Stroke({color:"#000000",width:2})}),text:new r.style.Text({textAlign:"center",scale:1.3,fill:new r.style.Fill({color:"#fff"}),stroke:new r.style.Stroke({color:"#6C0492",width:3.5})})}),M=new r.style.Style({fill:new r.style.Fill({color:"rgba(200, 100, 100, 0.2)"}),stroke:new r.style.Stroke({color:"rgba(255, 0, 0, 0.5)",width:3}),image:new r.style.Circle({radius:5,fill:new r.style.Fill({color:"#ffcc33"}),stroke:new r.style.Stroke({color:"#000000",width:2})}),text:new r.style.Text({textAlign:"center",scale:1.3,fill:new r.style.Fill({color:"#fff"}),stroke:new r.style.Stroke({color:"#C3000B",width:3.5})}),zIndex:"Infinity"}),V=new r.layer.Vector({source:new r.source.Vector({projection:"EPSG:3857"}),visible:!1}),L=new r.layer.Group({title:s.basemaps,layers:[new r.layer.Tile({title:s.aerialmap,type:"base",visible:!1,source:new r.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})}),new r.layer.Tile({title:s.roadmap,type:"base",visible:!0,source:new r.source.OSM})]});null!=f&&(u.onlybase&&L.getLayers().clear(),L.getLayers().push(f));document.getElementById("popup"),document.getElementById("popup-content"),document.getElementById("popup-closer");var O=d.createCoordsOverlay("#mapedit",null,s.pegmanlabel),D=new r.control.LayerSwitcher,N=new r.Map({layers:[L,V],overlays:[O],projection:p,renderer:"canvas",target:"mapedit",view:new r.View({center:[0,0],zoom:2,minZoom:2}),controls:r.control.defaults().extend([D,new G.generateResizableControl({target:document.getElementById("stagelistpanel")})])});N.on("click",(function(e){W.getActive()||H.getActive()||null!==u&&!u.geographic||O.setPosition(e.coordinate)})),D.showPanel(),e("#stagelistpanel").resizable({handles:{e:e("#egrip")},resize:function(e,t){t.size.height=t.originalSize.height},stop:function(e,t){N.updateSize()},cancel:""});var H={init:function(){this.select=new r.interaction.Select({filter:function(e){return!!A[e.getId()]},style:function(e){var t=new r.style.Fill({color:"rgba(255,100,100,0.4)"}),o=new r.style.Stroke({color:"rgba(255, 0, 0, 1)",width:4});return[new r.style.Style({image:new r.style.Circle({fill:t,stroke:o,radius:5}),fill:t,stroke:o,text:new r.style.Text({text:""+e.get("stageposition"),textAlign:"center",scale:1.3,fill:new r.style.Fill({color:"#fff"}),stroke:new r.style.Stroke({color:"rgba(255, 0, 0, 1)",width:3.5})}),zIndex:"Infinity"})]}}),N.addInteraction(this.select),this.modify=new r.interaction.Modify({features:this.select.getFeatures(),style:new r.style.Style({image:new r.style.Circle({radius:5,fill:new r.style.Fill({color:"#3399CC"}),stroke:new r.style.Stroke({color:"#000000",width:2})})}),deleteCondition:function(e){return r.events.condition.shiftKeyOnly(e)&&r.events.condition.singleClick(e)}}),N.addInteraction(this.modify),this.setEvents()},setEvents:function(){C=this.select.getFeatures(),this.select.on("change:active",(function(){C.clear(),X()})),this.select.on("select",(function(){C.getLength()>0?e("#removefeature").prop("disabled",!1):X()})),this.modify.on("modifyend",(function(e){ee(),function(e,t,o,i){e.forEach((function(e){var a,n=e.get("stageid"),s=o.getFeatureById(n);s||((s=t.getFeatureById(n).clone()).setId(n),o.addFeature(s));for(var l=new r.geom.MultiPolygon([]),d=0,c=(a=s.get("idFeaturesPolygons").split(",")).length;d<c;d++)l.appendPolygon(i.getSource().getFeatureById(a[d]).getGeometry().clone());s.setGeometry(l)}))}(e.features,x,P,I.roads[w].vector),k=!0}))},getActive:function(){return!(!this.select.getActive()||!this.modify.getActive())},setActive:function(e){this.select.setActive(e),this.modify.setActive(e)}};H.init();var W={init:function(){N.addInteraction(this.Polygon),this.Polygon.setActive(!1),this.setEvents()},Polygon:new r.interaction.Draw({source:V.getSource(),type:"Polygon",style:new r.style.Style({fill:new r.style.Fill({color:"rgba(0, 0, 0, 0.05)"}),stroke:new r.style.Stroke({color:"#FAC30B",width:2}),image:new r.style.Circle({radius:5,fill:new r.style.Fill({color:"#ffcc33"}),stroke:new r.style.Stroke({color:"#000000",width:2})}),zIndex:"Infinity"})}),setEvents:function(){this.Polygon.on("drawend",(function(t){E=!1,S?(V.getSource().clear(),S=!1):(t.feature.setProperties({roadid:w,stageid:F,stageposition:b}),A[z]=!0,t.feature.setId(z),z++,I.roads[w].vector.getSource().addFeature(t.feature),function(t,o,i){var r=t.get("stageid"),a=t.get("roadid"),n=i.getFeatureById(r);n||((n=o.getFeatureById(r).clone()).setId(r),i.addFeature(n));"empty"===n.get("idFeaturesPolygons")?(n.setProperties({idFeaturesPolygons:""+t.getId()}),function(t,o){var i=e('#stagelist li[stageid="'+t+'"]');if(i.children(".handle, .nohandle").addClass("validstage").removeClass("invalidstage"),o){e("label[for='addradio']").removeClass("highlightbutton"),0===e("#stagelist li[roadid='"+o+"']").find(".invalidstage").length&&e("#erremptystage").addClass("invisible")}}(r,a)):n.setProperties({idFeaturesPolygons:n.get("idFeaturesPolygons")+","+t.getId()});n.getGeometry().appendPolygon(t.getGeometry())}(t.feature,x,P),V.getSource().clear(),ee(),k=!0)})),this.Polygon.on("drawstart",(function(e){E=!0}))},getActive:function(){return this.Polygon.getActive()},setActive:function(e){e?this.Polygon.setActive(!0):this.Polygon.setActive(!1),N.getTargetElement().style.cursor=e?"none":""}};e(document).keyup((function(e){27===e.keyCode&&E&&(S=!0,W.Polygon.finishDrawing())})),W.init(),Q(),U();var q=new r.interaction.Snap({source:V.getSource()});function R(e){var t=e.get("stageposition");return isNaN(t)||(M.getText().setText(""+t),_.getText().setText(""+t)),A[e.getId()]?[M]:[_]}function K(t,o){var i=0;for(var r in t)if(I.roads.hasOwnProperty(r)){i=1,t[w=r].blocked?Z():Y(),ie(w,t[w].vector,o);break}0===i&&(Z(),e("#addroad").addClass("highlightbutton").blur(),e("#stagelistpanel").addClass("invisible"),o.updateSize())}function J(t,o){(e('#stagelist li[stageid="'+t+'"]').children(".handle,.nohandle").addClass("invalidstage").removeClass("validstage"),o)&&(e("label[for='addradio']").addClass("highlightbutton"),e("#stagelist li[roadid='"+o+"']").length>=2&&e("#erremptystage").removeClass("invisible"))}function X(){e("#removefeature").prop("disabled",!0)}function Y(){e("#addstage").prop("disabled",!1)}function Z(){e("#addstage").prop("disabled",!0)}function U(){e("#editmode").prop("disabled",!0),e("#drawmode").prop("disabled",!0),Q()}function Q(){e("#editmode").removeClass("selectedbutton").prop("z-index","Infinity"),e("#drawmode").removeClass("selectedbutton").prop("z-index","Infinity"),e("#navmode").prop("disabled",!1).addClass("selectedbutton").blur().prop("z-index",999),W.setActive(!1),H.setActive(!1)}function $(){e("#editmode").addClass("selectedbutton").blur().prop("z-index",999),e("#drawmode").removeClass("selectedbutton").prop("z-index","Infinity"),e("#navmode").removeClass("selectedbutton").prop("z-index","Infinity"),W.setActive(!1),H.setActive(!0)}function ee(){e("#savestage").prop("disabled",!1)}function te(e,t,o){var i=e.getView();o?i.fit(o,{duration:700}):i.animate({zoom:19,center:t,duration:700})}function oe(t){t.length>0?(e("#stagelistpanel").removeClass("invisible"),N.updateSize()):(e("#stagelistpanel").addClass("invisible"),N.updateSize()),t.length<2?(e("#addstage").addClass("highlightbutton").blur(),e("#errvalidroad").removeClass("invisible"),e("#erremptystage").addClass("invisible")):t.find(".invalidstage").length>0?(e("#addstage").removeClass("highlightbutton"),e("#errvalidroad").addClass("invisible"),e("#erremptystage").removeClass("invisible")):(e("#addstage").removeClass("highlightbutton"),e("#errvalidroad").addClass("invisible"),e("#erremptystage").addClass("invisible"))}function ie(t,o,i){e("#stagelist li").removeClass("ui-selected").hide();var a=e("#stagelist li[roadid='"+t+"']");a.show(),oe(a),e("#roadlist li[roadid='"+t+"']").addClass("ui-selected"),i.getLayers().forEach((function(e){e instanceof r.layer.Vector&&e.setVisible(!1)})),o.setVisible(!0),o.getSource().getFeatures().length>0&&te(i,null,o.getSource().getExtent())}function re(e,t){var o="editstage.php?cmid="+t+"&id="+e;window.location.href=o}function ae(e,t){var o="editstage.php?cmid="+t+"&roadid="+e;window.location.href=o}function ne(e,t){var o="editroad.php?cmid="+t+"&id="+e;window.location.href=o}function se(e){var t="editroad.php?cmid="+e;window.location.href=t}function le(t,o,r,n,s){e(".treasurehunt-editor-loader").show(),a.call([{methodname:"mod_treasurehunt_delete_road",args:{roadid:t,treasurehuntid:n,lockid:s}}])[0].done((function(a){if(e(".treasurehunt-editor-loader").hide(),a.status.code)i.alert("Error",a.status.msg,"Continue");else{!function(t){var o=e('#roadlist li[roadid="'+t+'"]');if(o.length>0){var i=e('#stagelist li[roadid="'+t+'"]');o.remove(),i.remove()}}(t),N.removeLayer(I.roads[t].vector),delete I.roads[t],K(I.roads,N),U();for(var n=r.getFeatures(),s=0;s<n.length;s++)if(t===n[s].get("roadid")){var l=o.getFeatureById(n[s].getId());l&&o.removeFeature(l),r.removeFeature(n[s])}}})).fail((function(t){e(".treasurehunt-editor-loader").hide(),console.log(t),i.exception(t)}))}function de(t,o,r,n,s,l){e(".treasurehunt-editor-loader").show(),a.call([{methodname:"mod_treasurehunt_delete_stage",args:{stageid:t,treasurehuntid:s,lockid:l}}])[0].done((function(a){if(e(".treasurehunt-editor-loader").hide(),a.status.code)i.alert("Error",a.status.msg,"Continue");else{var s,l=!1,d=o.getFeatureById(t);if(function(t,o,i,r){var a=e('#stagelist li[stageid="'+t+'"]');if(a.length>0){var n=a.attr("roadid"),s=a.index('li[roadid="'+n+'"]');a.remove();var l=e("#stagelist li[roadid='"+n+"']");oe(l);for(var d=l.length,c=0;c<=s-1;c++)j(l,d,c,o,i,r)}}(t,o,r,n),d?("empty"!==d.get("idFeaturesPolygons")&&(l=d.get("idFeaturesPolygons").split(",")),o.removeFeature(d)):("empty"!==(d=r.getFeatureById(t)).get("idFeaturesPolygons")&&(l=d.get("idFeaturesPolygons").split(",")),r.removeFeature(d)),l)for(var c=0,u=l.length;c<u;c++)s=n.getSource().getFeatureById(l[c]),n.getSource().removeFeature(s)}})).fail((function(t){e(".treasurehunt-editor-loader").hide(),console.log(t),i.exception(t)}))}function ce(t,o,n,s,l,d){e(".treasurehunt-editor-loader").show();var c,u=new r.format.GeoJSON,p=t.getFeatures(),f=[];p.forEach((function(e){(c=e.clone()).unset("idFeaturesPolygons"),c.unset("name"),c.unset("clue"),c.unset("treasurehuntid"),c.setId(e.getId()),f.push(c)}));var h=u.writeFeaturesObject(f,{dataProjection:"EPSG:4326",featureProjection:g});a.call([{methodname:"mod_treasurehunt_update_stages",args:{stages:h,treasurehuntid:n,lockid:d}}])[0].done((function(r){var a;(e(".treasurehunt-editor-loader").hide(),r.status.code)?i.alert("Error",r.status.msg,"Continue"):(t.forEachFeature((function(e){(a=o.getFeatureById(e.getId())).setProperties(e.getProperties()),a.setGeometry(e.getGeometry())})),t.clear(),e("#savestage").prop("disabled",!0),k=!1,"function"==typeof s&&l instanceof Array&&s.apply(null,l))})).fail((function(t){e(".treasurehunt-editor-loader").hide(),console.log(t),i.alert("Error",t.message,"Continue")}))}N.addInteraction(q),function(t){var o=a.call([{methodname:"mod_treasurehunt_fetch_treasurehunt",args:{treasurehuntid:t}}]);o[0].done((function(t){if(e(".treasurehunt-editor-loader").hide(),t.status.code)i.alert("Error",t.status.msg,"Continue");else{t.treasurehunt.stages;var o,a,n=new r.format.GeoJSON,s=t.treasurehunt.roads;Array.isArray(s)||(s=Object.values(s)),s.forEach((function(t){t.blocked=1==t.blocked,function(t,o,i){if(e('#roadlist li[roadid="'+t+'"]').length<1){e('<li roadid="'+t+'" blocked="'+i+'"/>').appendTo(e("#roadlist")).addClass("ui-corner-all").append("<div class='roadname'>"+o+"</div>").append("<div class='modifyroad'><span class='ui-icon ui-icon-trash'></span><span class='ui-icon ui-icon-pencil'></span></div>")}}(t.id,t.name,t.blocked),a=n.readFeatures(t.stages,{dataProjection:"EPSG:4326",featureProjection:g}),x.addFeatures(a),delete t.stages,o=new r.layer.Vector({source:new r.source.Vector({projection:g}),updateWhileAnimating:!0,style:R}),a.forEach((function(i){null===i.getGeometry()&&i.setGeometry(new r.geom.MultiPolygon([]));for(var a=i.getGeometry().getPolygons(),n="empty",s=i.get("stageposition"),l=i.get("name"),d=i.get("clue"),c=i.getId(),u=t.blocked,g=0;g<a.length;g++){var p=new r.Feature(i.getProperties());p.setProperties({stageid:c});var f=a[g];p.setGeometry(f),p.setId(z),n=0===g?z:n+","+z,z++,o.getSource().addFeature(p)}i.setProperties({idFeaturesPolygons:""+n}),function(t,o,i,r,a,n){if(e('#stagelist li[stageid="'+t+'"]').length<1){var s=e('<li stageid="'+t+'" roadid="'+o+'" stageposition="'+i+'"/>').appendTo(e("#stagelist"));s.addClass("ui-corner-all").append("<div class='stagename'>"+r+"</div>").append("<div class='modifystage'><span class='ui-icon ui-icon-pencil'></span><span class='ui-icon ui-icon-info' data-id='#dialoginfo"+t+"'><div id='dialoginfo"+t+"' title='"+r+"'>"+a+"</div></span></div>"),n?s.addClass("blocked").prepend("<div class='nohandle validstage'><span class='ui-icon ui-icon-locked'></span><span class='sortable-number'>"+i+"</span></div>"):(s.prepend("<div class='handle validstage'><span class='ui-icon ui-icon-arrowthick-2-n-s'></span><span class='sortable-number'>"+i+"</span></div>"),s.children(".modifystage").prepend("<span class='ui-icon ui-icon-trash'></span>")),e("#dialoginfo"+t).dialog({maxHeight:500,autoOpen:!1})}else console.log("El li con "+t+" no ha podido crearse porque ya existia uno")}(c,t.id,s,l,d,u),0===a.length&&J(c)})),t.vector=o,N.addLayer(o),I.roads[t.id]=t})),e("#stagelist li").sort((function(t,o){var i=parseInt(e(t).attr("stageposition")),r=parseInt(e(o).attr("stageposition"));return i<r?1:i>r?-1:0})).appendTo(e("#stagelist")),void 0!==I.roads[l]?(w=l,I.roads[w].blocked?Z():Y(),ie(w,I.roads[w].vector,N)):K(I.roads,N)}})).fail((function(t){e(".treasurehunt-editor-loader").hide(),console.log(t),i.exception(t)}))}(o),e(".searchaddress").autocomplete({minLength:4,source:function(e,t){var o=e.term;B&&B.abort(),B=n.search(o).done((e=>{if(0!==e.length){for(var o=[],i=0,r=e.length;i<r;i++){var a,n;a=e[i].lat,n=e[i].lon;var s={value:e[i].display_name,latitude:a,longitude:n,boundingbox:e[i].boundingbox};o[i]=s}t(o)}else t()})).fail((()=>{t()})).always((()=>{B=null}))},select:function(e,t){if(t.item.boundingbox){var o=[];o[0]=parseFloat(t.item.boundingbox[2]),o[1]=parseFloat(t.item.boundingbox[0]),o[2]=parseFloat(t.item.boundingbox[3]),o[3]=parseFloat(t.item.boundingbox[1]),o=r.proj.transformExtent(o,"EPSG:4326",g),te(N,null,o)}else{var i=r.proj.fromLonLat([t.item.longitude,t.item.latitude]);te(N,i)}},autoFocus:!0}).on("click",(function(){e(this).autocomplete("search",e(this).value)})),e.ui.autocomplete.prototype._resizeMenu=function(){this.menu.element.outerWidth(this.element.outerWidth())},e("#drawmode").css("position","relative").on("click",(function(){e("#drawmode").addClass("selectedbutton").blur().prop("z-index","Infinity"),e("#editmode").removeClass("selectedbutton").prop("z-index","auto"),e("#navmode").removeClass("selectedbutton").prop("z-index","auto"),H.setActive(!1),W.setActive(!0)})),e("#editmode").css("position","relative").on("click",$),e("#navmode").css("position","relative").on("click",Q),e("#addstage").on("click",(function(){k?ce(P,x,o,ae,[w,t],c):ae(w,t)})),e("#addroad").on("click",(function(){k?ce(P,x,o,se,[t],c):se(t)})),e("#removefeature").on("click",(function(){i.confirm(s.areyousure,s.removewarning,s.confirm,s.cancel,(function(){!function(e,t,o,i){e.forEach((function(e){var a,n,s=e.get("stageid"),l=e.get("roadid"),d=o.getFeatureById(s);d||((d=t.getFeatureById(s).clone()).setId(s),o.addFeature(d));for(var c=new r.geom.MultiPolygon([]),u=0,g=(a=d.get("idFeaturesPolygons").split(",")).length;u<g;u++)a[u]!=e.getId()?c.appendPolygon(i.getSource().getFeatureById(a[u]).getGeometry().clone()):n=u;d.setGeometry(c),c.getPolygons().length?(a.splice(n,1),d.setProperties({idFeaturesPolygons:a.join()})):(d.setProperties({idFeaturesPolygons:"empty"}),J(s,l))}))}(C,x,P,I.roads[w].vector),function(e,t){e.forEach((function(e){t.getSource().removeFeature(e)})),e.clear()}(C,I.roads[w].vector),X(),ee(),k=!0}))})),e("#savestage").on("click",(function(){ce(P,x,o,null,null,c)})),e("#stagelist").on("click",".ui-icon-info, .ui-icon-alert",(function(){var t=e(this).data("id");e(t).dialog("open"),e(".ui-dialog :button").blur()})),e("#stagelist").on("click",".ui-icon-trash",(function(){var t=e(this).parents("li");i.confirm(s.areyousure,s.removewarning,s.confirm,s.cancel,(function(){de(parseInt(t.attr("stageid")),P,x,I.roads[w].vector,o,c)}))})),e("#stagelist").on("click",".ui-icon-pencil",(function(){var i=parseInt(e(this).parents("li").attr("stageid"));k?ce(P,x,o,re,[i,t],c):re(i,t)}));e("#stagelist").on("click","li",(function(t){e(t.target).is(".handle ,.nohandle, .ui-icon , .sortable-number")?t.preventDefault():(e(this).addClass("ui-selected").siblings().removeClass("ui-selected"),b=parseInt(e(this).attr("stageposition")),F=parseInt(e(this).attr("stageid")),function(e,t,o,i,r,a){t.getSource().clear(),i.clear(),A={};var n=r.getFeatureById(o);if(n||(n=a.getFeatureById(o)))if("empty"!==n.get("idFeaturesPolygons")){for(var s=n.get("idFeaturesPolygons").split(","),l=0,d=s.length;l<d;l++)t.getSource().addFeature(e.getSource().getFeatureById(s[l]).clone()),A[s[l]]=!0;t.getSource().getFeatures().length&&te(N,null,t.getSource().getExtent())}else e.changed();else e.changed()}(I.roads[w].vector,T,F,C,P,x),e("#drawmode").prop("disabled",!1),e("#editmode").prop("disabled",!1),$(),e(this).find(".invalidstage").length>0?e("label[for='addradio']").addClass("highlightbutton"):e("label[for='addradio']").removeClass("highlightbutton"),E&&(S=!0,W.Polygon.finishDrawing()))})),e("#roadlist").on("click","li",(function(t){if(e(t.target).is(".ui-icon"))t.preventDefault();else{e(this).addClass("ui-selected").siblings().removeClass("ui-selected"),A={},E&&(S=!0,W.Polygon.finishDrawing()),w=e(this).attr("roadid");var o,i=e(this).attr("blocked");parseInt(i)||"true"===i?Z():Y(),ie(w,I.roads[w].vector,N),U(),o="fixed"===e("header[role=banner]").css("position")?parseInt(e(".treasurehunt-editor").offset().top)-parseInt(e("header[role=banner]").outerHeight(!0)):parseInt(e(".treasurehunt-editor").offset().top),e("html, body").animate({scrollTop:o},500)}})),e("#roadlist").on("click",".ui-icon-pencil",(function(){var i=parseInt(e(this).parents("li").attr("roadid"));k?ce(P,x,o,ne,[i,t],c):ne(i,t)})),e("#roadlist").on("click",".ui-icon-trash",(function(){var t=e(this).parents("li");i.confirm(s.areyousure,s.removeroadwarning,s.confirm,s.cancel,(function(){le(parseInt(t.attr("roadid")),P,x,o,c)}))})),N.on("pointermove",(function(e){if(!e.dragging&&!W.getActive()&&H.getActive()){var t=N.getEventPixel(e.originalEvent),o=N.forEachFeatureAtPixel(t,(function(e,t){if(A[e.getId()]){var o=!1;return C.forEach((function(t){e===t&&(o=!0)})),!o}return!1}));N.getTargetElement().style.cursor=o?"pointer":""}})),e(document).on("touchend",".ui-dialog-titlebar-close",(function(){e(this).parent().siblings(".ui-dialog-content").dialog("close")})),e(".searchaddress").on("input",(function(){var t;e(".closeicon")[(t=this.value,t?"removeClass":"addClass")]("invisible")})),e(".closeicon").on("touchstart click",(function(t){t.preventDefault(),e(this).addClass("invisible"),e(".searchaddress").val("").change().autocomplete("close")})),window.onbeforeunload=function(e){var t=s.savewarning;e=e||window.event;if(k)return e&&(e.returnValue=t),t}}return{edittreasurehunt:function(e,t,o,r,a){var n=["stage","road","aerialmap","roadmap","basemaps","add","modify","save","remove","searchlocation","savewarning","removewarning","areyousure","removeroadwarning","confirm","cancel","pegmanlabel","custommapimageerror"],s=n.map((function(e){return{key:e,component:"treasurehunt"}}));l.get_strings(s).done((function(s){for(var l=[],d=0;d<n.length;d++)l[n[d]]=s[d];if(null!=a&&null!==a.custombackgroundurl){var u=new Image;u.onload=function(){a.imgwidth=this.naturalWidth,a.imgheight=this.naturalHeight,c(e,t,l,o,r,a)},u.onerror=function(n){i.alert("Error",l.custommapimageerror,"Continue"),c(e,t,l,o,r,a)},u.src=a.custombackgroundurl}else c(e,t,l,o,r,a)}))}}}));