/**
 * @module    mod_treasurehunt/play
 * @package   mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>, Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(["jquery","core/url","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/viewgpx","core/str","mod_treasurehunt/webqr","mod_treasurehunt/jquery.truncate","mod_treasurehunt/dropdown"],(function(e,t,a,o,s,l,n,i){return{playtreasurehunt:function(e,t,a,o,s,l,i,c,u,d){let m=["stageovercome","failedlocation","stage","stagename","stageclue","question","noanswerselected","timeexceeded","searching","continue","noattempts","aerialview","roadview","noresults","startfromhere","nomarks","updates","activitytoendwarning","huntcompleted","discoveredlocation","answerwarning","error","pegmanlabel"],g=m.map((e=>({key:e,component:"treasurehunt"})));n.get_strings(g).done((n=>{let g=[];for(let e=0;e<m.length;e++)g[m[e]]=n[e];if(void 0!==d&&d&&d.custombackgroundurl){let n=new Image;n.addEventListener("load",(function(){d.imgwidth=this.naturalWidth,d.imgheight=this.naturalHeight,r(g,e,t,a,o,s,l,i,c,u,d)})),n.src=d.custombackgroundurl}else r(g,e,t,a,o,s,l,i,c,u,d)}))}};function r(n,r,c,u,d,m,g,p,y,f,h){ke(!0);let v="EPSG:3857",w=null,b=!0,x=15,k="ontouchstart"in window||navigator.msMaxTouchPoints;if(h){if(h.custombackgroundurl){var P=function(e,t,o=!1){var s=a.proj.transformExtent(e.bbox,"EPSG:4326",t);if(1==e.preserveaspectratio){s[2],s[0];var l=s[3]-s[1],n=(s[2]+s[0])/2,i=(s[3]+s[1])/2,r=Math.round(l/e.imgheight),c=Math.round(e.imgwidth*r),u=Math.round(e.imgheight*r);o?s=[n-c/2,i-u/2,n+c/2,i+u/2]:(s=[s[0],s[1],s[0]+c,s[1]+u],console.log("Using bottom-left as reference."+s))}return s}(h,v,!1);x=5,w=new a.layer.Image({title:h.layername,name:h.layername,type:h.layertype,source:new a.source.ImageStatic({url:h.custombackgroundurl,imageExtent:P}),opacity:1})}else if(h.wmsurl){let e={type:h.layertype,title:h.layername,name:h.layername};if("wms"===h.layerservicetype?e.source=new a.source.TileWMS({url:h.wmsurl,params:h.wmsparams}):"tiled"===h.layerservicetype?e.source=new a.source.XYZ({url:h.wmsurl}):"arcgis"===h.layerservicetype&&(e.source=new a.source.TileArcGISRest({url:h.wmsurl})),h.bbox[0]&&h.bbox[1]&&h.bbox[2]&&h.bbox[3]){let t=a.proj.transformExtent(h.bbox,"EPSG:4326",v);e.extent=t}w=new a.layer.Tile(e),w.set("name",h.layername)}b=h.geographic}!1===b&&(u=!0,e("#autolocate").hide());let S,E,G=t.imageUrl("success_mark","treasurehunt"),T=t.imageUrl("failure_mark","treasurehunt"),C=t.imageUrl("bootstrap/my_location_3","treasurehunt"),I={},_=[],q=[],F=!1,j=!1,V=!1,A=!1,z=!1,M=!0,D=!1,L=0,R=new a.style.Text({textAlign:"center",scale:1.3,fill:new a.style.Fill({color:"#ffffff"}),stroke:new a.style.Stroke({color:"#000000",width:3.5})}),$=new a.style.Text({textAlign:"center",scale:1.4,fill:new a.style.Fill({color:"#fff"}),stroke:new a.style.Stroke({color:"#0097a7",width:3.5})}),O=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:G}),text:R,zIndex:"Infinity"}),N=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:T}),text:R,zIndex:"Infinity"}),Q=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:G}),text:$,zIndex:"Infinity"}),W=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:T}),text:$,zIndex:"Infinity"}),U=new a.style.Style({image:new a.style.Circle({radius:6,fill:new a.style.Fill({color:[0,0,0,1]}),stroke:new a.style.Stroke({color:[255,255,255,1],width:2})})}),Z=new a.style.Style({fill:new a.style.Fill({color:[255,255,255,.3]}),stroke:new a.style.Stroke({color:[0,0,0,.5],width:1}),zIndex:-1}),B=new a.style.Style({image:new a.style.Icon({anchor:[.5,.9],opacity:1,scale:1,src:C})}),H=[],X=new a.format.GeoJSON,Y=new a.source.Vector({projection:"EPSG:3857"}),K=new a.layer.Vector({source:Y,style:function(e){let t=e.get("stageposition");if(0===t){let e=new a.style.Fill({color:"rgba(0,0,0,0.1)"}),t=new a.style.Stroke({color:"#0097a7",width:2});return[new a.style.Style({image:new a.style.Circle({fill:e,stroke:t,radius:5}),fill:e,stroke:t,text:new a.style.Text({text:n.startfromhere,textAlign:"center",fill:new a.style.Fill({color:"rgb(255,255,255)"}),stroke:new a.style.Stroke({color:"#0097a7",width:2}),overflow:!0,scale:2})})]}if(!e.get("geometrysolved"))return N.getText().setText(""+t),[N];return O.getText().setText(""+t),[O]}}),J=[],ee=[];if(!h||!1===h.onlybase){let e=new a.layer.Tile({visible:!1,source:new a.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})}),t=new a.layer.Tile({source:new a.source.OSM});e.set("name",n.aerialview),t.set("name",n.roadview),J=[e,t]}w&&("overlay"!=h.layertype?J.push(w):ee.push(w));let te=new a.layer.Group({layers:J});var ae=l.createCoordsOverlay("#mapplay","css/playerbootstrap/ol-popup.css",n.pegmanlabel);let oe=null;te.getLayers().forEach((e=>{e.setVisible(!1),oe=e})),oe.setVisible(!0);let se=new a.View({center:[0,0],zoom:2,minZoom:2}),le=new a.interaction.Select({layers:[K],style:function(e){let t=e.get("stageposition");if(!e.get("geometrysolved"))return W.getText().setText(""+t),[W];return Q.getText().setText(""+t),[Q]},filter:e=>0!==e.get("stageposition")}),ne=new a.Feature;ne.setProperties({name:"user_accuracy"}),ne.setStyle(Z);let ie=new a.Feature;ie.setProperties({name:"user_position"}),ie.setStyle(U);let re=new a.layer.Vector({source:new a.source.Vector({features:[ne,ie]})}),ce=new a.Feature;ce.setGeometry(null),ce.setStyle(B);let ue=new a.layer.Vector({source:new a.source.Vector({features:[ce]})});H.push(te),H=H.concat(ee),H=H.concat([K,re,ue]);let de=new a.control.Zoom({target:"navigation",className:"custom-zoom"}),me=new a.Map({layers:H,overlays:[ae],controls:[de],target:"mapplay",view:se,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0});if(me.addInteraction(le),pe(!1,!0),S=setInterval((()=>{pe(!1,!1)}),p),function(t){t.getLayers().forEach((a=>{let o=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.getLayers().forEach((e=>{e===a?e.setVisible(!0):e.setVisible(!1)}))})),s=e("<i>",{class:"fa fa-check-circle"+(a.getVisible()?"":" unchecked")}),l=e("<div>",{text:a.get("name"),class:"layer-item "}).append(s);o.append(l),a.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(o)}))}(te),ee.forEach((e=>{ye(e)})),y&&f){let e=l.addgpxlayer(me,r,c,n,f,"trackgroup");e.set("name",e.get("title"));let t=e.getLayers().item(0),a=t.get("title");t.set("name",a),t.setVisible(!1),ye(t)}function ge(e,t,a){let o=e.getView();a?o.fit(a,{duration:700}):o.animate({zoom:x,center:t,duration:700})}function pe(t,s,l,i){let r,p,f,h;f=u?ce.getGeometry():ie.getGeometry(),f&&(p=X.writeGeometryObject(f,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),l&&(ke(!0),h=l),t&&(r=p,ke(!0)),o.call([{methodname:"mod_treasurehunt_user_progress",args:{userprogress:{treasurehuntid:c,attempttimestamp:m,roadtimestamp:g,playwithoutmoving:u,groupmode:d,initialize:s,location:r,currentposition:y&&!u?p:void 0,selectedanswerid:h,qoaremoved:D,qrtext:i}}}])[0].done((o=>{if(D=o.qoaremoved,z=o.roadfinished,M=o.available,ke(!1),(t||l)&&(null!==o.status&&M&&ve(o.status.msg),ce.setGeometry(null)),u!=o.playwithoutmoving&&((u=o.playwithoutmoving)||ce.setGeometry(null)),d!=o.groupmode&&(d=o.groupmode),m===o.attempttimestamp&&g===o.roadtimestamp&&!s&&M||(m=o.attempttimestamp,g=o.roadtimestamp,o.attempthistory.length>0&&(q=o.attempthistory,F=!0),(o.attempts||o.firststagegeom)&&(Y.clear(),o.firststagegeom&&Y.addFeatures(X.readFeatures(o.firststagegeom,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),o.attempts.features.length>0&&Y.addFeatures(X.readFeatures(o.attempts,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"}))),o.lastsuccessfulstage&&(I=o.lastsuccessfulstage,j=!0,we("#cluepage"),e("#validateqr").hide(),""!==I.question?(V=!0,e("#validatelocation").hide()):I.activitysolved?(e("#validatelocation").show(),o.qrexpected&&e("#validateqr").show()):e("#validatelocation").hide()),(o.firststagegeom||s)&&(A=!0),j&&(I.clue=I.clue.replace(/color/gm,"color-disabled"),e("#lastsuccessfulstageclue").html(I.clue),e("#lastsuccessfulstagename").text(I.name),e("#lastsuccesfulstagepos").text(I.position+" / "+I.totalnumber),""!==I.question?e("#questionbutton").show():e("#questionbutton").hide(),j=!1),function(){if(A){let e=Y.getFeatures();1===e.length&&e[0].getGeometry()instanceof a.geom.Point?ge(me,e[0].getGeometry().getCoordinates()):ge(me,null,Y.getExtent()),A=!1}}(),function(){if(V){I.question=I.question.replace(/color/gm,"color-disabled"),e("#questionform").html("<legend>"+I.question+"</legend>");let t=1;e.each(I.answers,((a,o)=>{let s="answer"+t;o.answertext=o.answertext.replace(/color/gm,"color-disabled"),e("#questionform").append(`<div class="form-check">\n                <input class="form-check-input" type="radio" name="answers" id="${s}" value="${o.id}">\n                <label class="form-check-label" for="${s}">\n                  ${o.answertext}\n                </label>\n            </div>`),t++})),V=!1}}(),function(){if(F){let t=e("#historylist");t.html(""),F=!1,0===q.length?e("<li>"+n.noattempts+"</li>").appendTo(t):q.forEach((a=>{e("<li><span class='ui-btn-icon-left "+(a.penalty?"ui-icon-delete failedattempt":"ui-icon-check successfulattempt")+"' style='position:relative'></span>"+a.string+"</li>").appendTo(t)}))}}()),o.infomsg.length>0){let t="";_.forEach((e=>{t+="<p>"+e+"</p>"})),o.infomsg.forEach((e=>{_.push(e),t+="<p>"+e+"</p>"})),e("#notificationsPopup .update-list").html(t),we("#notificationsPopup")}z||e("#roadended").hide(),!z&&M||(e("#validatelocation").hide(),e("#question_button").hide(),e("#roadended").show(),ce.setGeometry(null),u=!1,clearInterval(S),e("#mapplay").css("opacity","0.8"))})).fail((t=>{e("#errorPopup .play-modal-content").text(t.message),we("#errorPopup"),clearInterval(S)}))}function ye(t){let a=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.setVisible(!t.getVisible())})),o=e("<div>").append(e.parseHTML(t.get("name"))),s=e("<i>",{class:"fa fa-check-circle"+(t.getVisible()?"":" unchecked")}),l=e("<div>",{class:"layer-item"}).append(o,s);a.append(l),t.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(a)}let fe=new a.Geolocation({projection:se.getProjection(),trackingOptions:{enableHighAccuracy:!0,maximumAge:0,timeout:1e4}});fe.on("change:position",(()=>{let e=fe.getPosition();ie.setGeometry(e?new a.geom.Point(e):null),fe.get("center")&&(ge(me,e),fe.setProperties({center:!1})),fe.get("validate_location")&&(pe(!0,!1),fe.setProperties({validate_location:!1}))})),fe.on("change:accuracyGeometry",(()=>{ne.setGeometry(fe.getAccuracyGeometry())}));let he=!1;function ve(t){const a=e(`<div class='play-toast slide-in-bottom'>${t}</div>`);a.appendTo(e(".play-toast-container")),setTimeout((()=>a.addClass("slide-out-top")),3e3),setTimeout((()=>a.remove()),3500)}function we(t){be();const a=e(t);a.trigger("modal:open"),a.addClass("active"),e(`${t} .modal-mask`).addClass("active dismissible")}function be(){const t=e(".play-modal.active");t.trigger("modal:close"),t.removeClass("active"),e(".modal-mask").removeClass("active dismissible")}function xe(e,t){return`<div class="card">\n          <div class="card-body">\n            <h5 class="card-title">${e}</h5>\n            <h6 class="card-subtitle text-muted">${t}</h6>\n          </div>\n      </div>`}function ke(t){t?e(".global-loader").addClass("active"):e(".global-loader").removeClass("active")}function Pe(e){be(),ve("QR code readed: "+e),pe(!1,!1,null,e)}function Se(t){"string"==typeof t?e("#errorQR").text(t):(null!==t.cameras[t.camera].name&&e("#errorQR").text(t.cameras[t.camera].name),t.cameras.length>1?e("#nextcamera").show():e("#nextcamera").hide())}fe.on("error",(e=>{fe.setProperties({user_denied:!0}),ve(e.message),e.code==e.PERMISSION_DENIED&&y&&!u&&0==he&&setTimeout((()=>{we("#geolocationPopup"),he=!0}),500)})),fe.setTracking(y),k||me.on("pointermove",(e=>{if(e.dragging)return;const t=me.getEventPixel(e.originalEvent);let o=!1;me.forEachFeatureAtPixel(t,(e=>{e.getGeometry()instanceof a.geom.MultiPolygon||(o=!0)}),{layerFilter:e=>e===K}),me.getTargetElement().style.cursor=o?"pointer":"crosshair"})),le.on("select",(t=>{if(1===t.selected.length){let a=t.selected[0].get("name"),o=t.selected[0].get("clue"),s=t.selected[0].get("info"),l="",i="";s&&(l="<p>"+s+"</p>"),t.selected[0].get("geometrysolved")?a&&o?(i=n.stageovercome,l+=xe(n.stagename,a),l+=xe(n.stageclue,o)):i=n.discoveredlocation:i=n.failedlocation,e("#infoStagePopup .title").text(i),e("#infoStagePopup .play-modal-content").html(l),we("#infoStagePopup")}})),me.on("click",(e=>{let t=!1;if(me.forEachFeatureAtPixel(me.getEventPixel(e.originalEvent),(e=>{if(0===e.get("stageposition")||"user_position"===e.get("name")||"user_accuracy"===e.get("name"))return!1;t=!0})),u&&!t){let t=me.getEventCoordinate(e.originalEvent);ce.setGeometry(t?new a.geom.Point(t):null),(null===h||h.geographic)&&ae.setPosition(e.coordinate)}})),e("#searchInput").on("input",(t=>{E&&E.abort(),L&&clearTimeout(L);const o=e("#searchsResults"),l=t.target.value;o.html(""),l&&l.length>2&&(e(".search-loading").addClass("active"),L=setTimeout((()=>{E=s.search(l).done((t=>{e(".search-loading").removeClass("active"),0===t.length?o.html("<li class='list-group-item'>"+n.noresults+"</li>"):e.each(t,((t,s)=>{let l=e("<button>",{type:"button",class:"list-group-item list-group-item-action"}).appendTo(o).click((()=>{let t=[];t[0]=parseFloat(s.boundingbox[2]),t[1]=parseFloat(s.boundingbox[0]),t[2]=parseFloat(s.boundingbox[3]),t[3]=parseFloat(s.boundingbox[1]),t=a.proj.transformExtent(t,"EPSG:4326","EPSG:3857"),ge(me,null,t),e("#searchpanel").removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),n=e("<div>",{text:s.display_name,class:"search-option"}).append(e("<i class='fa fa-chevron-circle-right'>"));l.append(n)}))})).fail((()=>{})).always((()=>{E=null}))}),400))})),e("#infoStagePopup").on("modal:close",(()=>{le.getFeatures().clear()})),e("#acceptupdates").on("click",(()=>{_=[]})),e("#qrpage").on("modal:open",(()=>{i.loadQR(Pe,Se)})),e("#qrpage").on("modal:close",(()=>{i.unloadQR(Se)})),e("#nextcamera").on("click",(()=>{let e=i.getDetectedCameras();if(null!==e){ve("Give access to:"+e[i.getnextwebCam()].name)}i.setnextwebcam(Se)})),e(window).on("resize",(()=>{me.updateSize()})),b&&e("#autolocate").on("click",(()=>{fe.get("user_denied")?we("#geolocationPopup"):function(){const e=fe.getPosition();ge(me,e)}()})),e("#infopanel").on("sidebar:close",(()=>{le.getFeatures().clear()})),e("#sendLocation").on("click",(()=>{u&&!ce.getGeometry()?ve(n.nomarks):pe(!0,!1)})),e("#sendAnswer").on("click",(t=>{let a=e("#questionform input[type='radio']:checked");M?0===a.length?(t.preventDefault(),ve(n.noanswerselected)):pe(!1,!1,a.val()):(t.preventDefault(),ve(n.timeexceeded))})),e("#validatelocation").on("click",(e=>z?(e.preventDefault(),void ve(n.huntcompleted)):M?""!==I.question?(e.preventDefault(),ve(n.answerwarning),void we("#cluepage")):I.activitysolved?void 0:(e.preventDefault(),ve(n.activitytoendwarning),void we("#cluepage")):(e.preventDefault(),void ve(n.timeexceeded)))),e(document).on("click",'*[data-rel="sidebar"]',(t=>{const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("sidebar:open"),o.addClass("active"),null!==a.dataset.dismissible&&e(".sidebar-mask").addClass("active dismissible")})),e(document).on("click",".close-sidebar, .sidebar-mask",(()=>{const t=e(".sidebar.active");t.trigger("sidebar:close"),t.removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),e(document).on("click",'*[data-rel="modal"]',(t=>{be();const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("modal:open"),o.addClass("active"),e(a.dataset.ref+" .modal-mask").addClass("active"),null!==a.dataset.dismissible&&e(a.dataset.ref+" .modal-mask").addClass("dismissible")})),e(document).on("click",".close-modal, .modal-mask.dismissible",(()=>{be()}))}}));